//############### Script Scilab written By ortollj ##############################
// 2016/07/29  corps finis
function [xdata,ydata] = makeXY(polyToDisplay,StartP,EndP,StepNumber,p);
x=poly(0,'x');
xdata = linspace (StartP,EndP , StepNumber);
ydata=horner(polyToDisplay,xdata);
end

function [xdata,ydata] = makeXYMod(polyToDisplay,StartP,EndP,StepNumber,p);
x=poly(0,'x');
xdata = linspace (StartP,EndP , StepNumber);
ydata=modulo(horner(polyToDisplay,xdata),p);
end


function IndexElement=GetFieldElementIndex(FieldElement,p,n)
// get the index of an field element
P=p^n; 
ElementsArray=[ 0 GetFieldElements(p,n,WorkPath)];

for i = 3 : P+1;
    // this line because of the bug comparison
     [polyO1,polyO2]=polySameDim(FieldElement,ElementsArray(i)) ; 
	if polyO1==polyO2 then
    
     IndexElement=i;
     disp ("IndexElement:" + string(IndexElement));
     break;
    end
end
endfunction

function powFieldElementsRow=BuildFieldPowLine(FieldElementRow,mm,p,n)
// get the power line of an field element without produce overflow
//a=Field element, mm=Field multiplication table
//(a^i * a^j) mod p =(a^(((i+j) mod (p-1))) mod p 
P=p^n;
powFieldElementsRow=[];
powFieldElementsRow(1)=mm(FieldElementRow,1);
powFieldElementsRow(2)=1;
powFieldElementsRow(3)=mm(FieldElementRow,1);
IndexNext=FieldElementRow; // first time, square it

for i = 4 : P+1;
	powFieldElementsRow(i)=mm(FieldElementRow,IndexNext);
    IndexNext=GetFieldElementIndex(powFieldElementsRow(i),p,n);
end
powFieldElementsRow=powFieldElementsRow' ; // column--> line
endfunction

// build power table
function mp=BuildMp(mm,p,n)
P=p^n;

mp = zeros(P+1,P+1);
//AllFieldPolyArrayElements=GetFieldElements(p,n,WorkPath) ;
//mp(:,1)=[ 0 AllFieldPolyArrayElements];
mp(1,:)= [0 0 1:P-1];// exponents on the first row
mp(2,:)=0 ;
mp(3,:)=1 ;
for FieldElementRow = 4 : P+1;
   // disp(FieldElementRow);
  mp(FieldElementRow,:)=BuildFieldPowLine(FieldElementRow,mm,p,n);
end
endfunction

//########################a way to work around this bug :ne-confondre-1-different-1-chez-scilab
//http://www.developpez.net/forums/d1597699/environnements-developpement/autres-edi/scilab/ne-confondre-1-different-1-chez-scilab/
function [polyO1,polyO2]=polySameDim(poly1,poly2)
	l1=length(coeff(poly1)) ;
	l2=length(coeff(poly2)) ;

		
	if l1> l2 then
		polyO2=  poly([coeff(poly2) zeros(1,l1 - l2) ],'x',"coeff") ;
	    polyO1=poly1 ;
	elseif  l2> l1 then
		polyO1=  poly([coeff(poly1) zeros(1,l2 - l1) ],'x',"coeff") ;
	    polyO2=poly2 ;
	else
	polyO1=poly1 ;
	polyO2=poly2 ;
	end

endfunction


function VerifiedPrimitivePolynomyals= ComputeAllPrimitivesPolynomials(p,n,WorkPath)

x=poly(0,'x');
irreduciblePolyStr='';

AllFieldPolyArrayElements=GetFieldElements(p,n,WorkPath) ;

Safpae=size(AllFieldPolyArrayElements);
AllPrimitivePolynomyals=AllFieldPolyArrayElements + x^n ;
VerifiedPrimitivePolynomyals=[AllPrimitivePolynomyals ; zeros(1,Safpae(2))];

P=p^n;

mm = zeros(P+1,P+1);

mm(1,:)=[ 0 AllFieldPolyArrayElements];
mm(:,1)=[ 0 AllFieldPolyArrayElements];
// ##################

    for indexPoly=1:Safpae(2)
        irreduciblePoly=  VerifiedPrimitivePolynomyals(1,indexPoly); 
        mm=MakeMultFieldMatrix(p,n,mm,VerifiedPrimitivePolynomyals(1,indexPoly),WorkPath) ;
        disp("mm Done with Poly not checked yet " + pol2str(irreduciblePoly) + "   mm size:" + string(size(mm))   );
        if SpotNum(mm) then
            disp("Now check out this polynomial " + pol2str(irreduciblePoly));
            // it is a primitive polynomial
            irreduciblePolyStr='';
            for i = 1 :length(coeff(irreduciblePoly))
                irreduciblePolyStr=irreduciblePolyStr+string(coeff(irreduciblePoly)(i));
            end
            disp("mm Done with  irreduciblePoly= " + pol2str(irreduciblePoly));
            VerifiedPrimitivePolynomyals(2,indexPoly)=1;
            disp(VerifiedPrimitivePolynomyals(1,indexPoly));
            CsvMatrix(mm,'multPoly' + irreduciblePolyStr,p,n,WorkPath);
        end   
    end
//
//rep = messagebox("transform new Csv just created to Xls, but do you want to delete old csv file ?" , "xls created from old Csv will not be deleted ",  "modal",["yes","no"]) ;
//
//if  rep == 1 then dos('del *.csv'); end
//
////CsvMatrix(ma,'addPoly' + irreduciblePolyStr,p,n,WorkPath);
//CsvMatrix(mm,'multPoly' + irreduciblePolyStr,p,n,WorkPath);
//
////  launch Excel
//dos('start excel.exe /r ImportCsvFiles4.xls')
endfunction


function FieldOk=SpotNum(mm)
x=poly(0,'x');
//fd_w = mopen(WorkPath +'\debugSpotNum.txt', 'wt');
S=size(mm) ;
//SpotNumM= ones(S(1),S(2)) ;
//SpotNumM(1,:)=0;
//SpotNumM(:,1)=0;
//SpotNumM(2,:)=0;
//SpotNumM(:,2)=0;
//AllElementCount=0;
FieldOk=%T ;
for r=3:S(1)
    // new row is tested
    // RowElementCount=0;
    TestRowFlag= mm(1,:) ;
	for c=3:S(2)
       
		for cv=3:S(2);
          [polyO1,polyO2]=polySameDim(mm(r,c),TestRowFlag(cv)) ;//work around this bug :ne-confondre-1-different-1-chez-scilab      
		  if polyO1 == polyO2 then
		  
//            AllElementCount=AllElementCount+1;
//            RowElementCount=RowElementCount+1;
//           mmrcStr=pol2str(mm(r,c));
//           mfprintf(  fd_w,"r:%2d  c:%2d  cv:%2d mmrc:%s AllElementCount:%d RowElementCount:%d \n",r,c,cv ,mmrcStr,AllElementCount,RowElementCount );
//		   SpotNumM(r,c)=0 ; 
           TestRowFlag(cv)=0 ; // Element found, so supress the Element in TestRowFlag (Element must not be found Twice !)
            break // ok, stop searching we got it
		  end 
      
		end

    
	end
       if TestRowFlag== zeros(1,S(2)) then
           
       else 
          // not all Field element has been found in this row--> not a   Field
          // or a field Element has been found Twice -> not a   Field
          FieldOk=%F ;
          return ; 
       end   
end

//mclose(fd_w);
endfunction


function [mm,ma,mp,mo]  =  DoItWithMyPrimitivePolynomial(p,n,WorkPath)

x=poly(0,'x');
//###########
irreduciblePolyR=(x^(n+1) - 1)/(x-1);


//Characteristic polynomials for 3^2
//irreduciblePoly=x^2+1
//irreduciblePoly=x^2+x+2
//irreduciblePoly=x^2+2 x+2

//Characteristic polynomials for 3^3
//irreduciblePoly=x^3+2 x+1
//irreduciblePoly=x^3+2 x+2
//irreduciblePoly=x^3+x^2+2
//irreduciblePoly=x^3+x^2+x+2
txt = ['Polynomial'];
sig = x_mdialog('enter F'+string(p)+ '^'+string(n)+' '+ 'Polynomial (Factors need *, example:2*x^3)',txt,[pol2str(irreduciblePolyR(2))]);
irreduciblePoly=evstr(sig(1));
//################
status= deletefile(WorkPath +'\debug.txt');
AllFieldPolyArrayElements=GetFieldElements(p,n,WorkPath) ;

P=p^n;
// matrices first column and first row initialisation
ma = zeros(P+1,P+1);
ma(1,:)=[ 0 AllFieldPolyArrayElements];
ma(:,1)=[ 0 AllFieldPolyArrayElements];
mm = zeros(P+1,P+1);
mm(1,:)=[ 0 AllFieldPolyArrayElements];
mm(:,1)=[ 0 AllFieldPolyArrayElements];

mo = zeros(P+1,P+1);
mo(1,:)=[ 0 AllFieldPolyArrayElements];
mo(:,1)=[ 0 AllFieldPolyArrayElements];

// ##################
irreduciblePolyStr='';
for i = 1 :length(coeff(irreduciblePoly))irreduciblePolyStr=irreduciblePolyStr+string(coeff(irreduciblePoly)(i)); end
ma=MakeAddFieldMatrix(p,n,ma,irreduciblePoly,WorkPath) ;
mm=MakeMultFieldMatrix(p,n,mm,irreduciblePoly,WorkPath) ;
if SpotNum(mm) then 
 //Compute Power Table Only if mm is a field
 // bug in computing Power table if mm not a Field (no time to resolve this bug !)
 // and this bug is not important
mp=BuildMp(mm,p,n);
CsvMatrix(mp,'PowerPoly' + irreduciblePolyStr,p,n,WorkPath);

LatexArray(mp,'PowerPoly_'+irreduciblePolyStr+'_'+string(p)+'E'+string(n),'^',WorkPath);
//omega table
for k = 3 : P+1 
	for j = 3 : P+1
      [polyO1,polyO2]=polySameDim(mp(k,j),1) ;//work around this bug :ne-confondre-1-different-1-chez-scilab      
	  if polyO1 == polyO2 then   
	   mo(k,j)=mp(1,j);  
	  break;
	  end
	end
end
end
CsvMatrix(mo,'Omega' + irreduciblePolyStr,p,n,WorkPath);
LatexArray(mo,'Omega_'+irreduciblePolyStr+'_'+string(p)+'E'+string(n),'.',WorkPath);

LatexArray(ma,'AddPoly_'+irreduciblePolyStr+'_'+string(p)+'E'+string(n),'+',WorkPath);
LatexArray(mm,'multPoly'+ irreduciblePolyStr+'_'+string(p)+'E'+string(n),'.',WorkPath);


rep = messagebox("transform new Csv just created to Xls, but do you want to delete old csv file ?" , "xls created from old Csv will not be deleted ",  "modal",["yes","no"]) ;

if  rep == 1 then dos('del *.csv'); end

CsvMatrix(ma,'addPoly' + irreduciblePolyStr,p,n,WorkPath);
CsvMatrix(mm,'multPoly' + irreduciblePolyStr,p,n,WorkPath);

//  launch Excel
dos('start excel.exe /r ImportCsvFiles4.xls')
endfunction





function ma  =  MakeAddFieldMatrix(p,n,ma,irreduciblePoly,WorkPath)
x=poly(0,'x');
P=p^n;


// compute addition and multiplication table modulo irreduciblePoly
for i = 2 : P+1 
	for j = 2 : P+1
	  ma(i,j)=modulo((ma(i,1)+ma(j,1)),irreduciblePoly) ;
	end
end
//reduce coefficients modulo p 
for i = 2 : P+1 
	for j = 2 : P+1
    ma(i,j)=poly(modulo(coeff(ma(i,j)),p),"x","coeff");
	end
end

//LatexArray(mm,'multiplicationWithNegativeCoeffs'+irreduciblePolyStr,'.',WorkPath);
//LatexArray(ma,'AdditionWithNegativeCoeffs'+irreduciblePolyStr,'+',WorkPath);

// commute negative sign
for i = 2 : P+1 
	for j = 2 : P+1
    ma(i,j)=poly(modulo(p+coeff(ma(i,j)),p),"x","coeff");
	end
end

endfunction

function mm  =  MakeMultFieldMatrix(p,n,mm,irreduciblePoly,WorkPath)
x=poly(0,'x');
P=p^n;

// compute addition and multiplication table modulo irreduciblePoly
for i = 2 : P+1 
	for j = 2 : P+1
	  mm(i,j)=modulo((mm(i,1)*mm(j,1)),irreduciblePoly) ;
	end
end
//reduce coefficients modulo p 
for i = 2 : P+1 
	for j = 2 : P+1
    mm(i,j)=poly(modulo(coeff(mm(i,j)),p),"x","coeff");
   
	end
end

//LatexArray(mm,'multiplicationWithNegativeCoeffs'+irreduciblePolyStr,'.',WorkPath);
//LatexArray(ma,'AdditionWithNegativeCoeffs'+irreduciblePolyStr,'+',WorkPath);

// commute negative sign
for i = 2 : P+1 
	for j = 2 : P+1  
    mm(i,j)=poly(modulo(p+coeff(mm(i,j)),p),"x","coeff");
	end
end

endfunction






// this function makes a CSV conversion of a matrix
// in the file WorkPath + '\'+ texto +' '+ string(p) + 'pow' + string(n)  + '.csv'
function CsvMatrix(PolyM,texto,p,n,WorkPath)
x=poly(0,'x');
 csvWrite(pol2str(PolyM), WorkPath + '\'+ texto +'_'+ string(p) + 'E' + string(n)  + '.csv' , CsvDelimiter);
  
endfunction

// this function makes a Latex conversion of a matrix
// in the file \Scilab\Work'+ texto + '.txt'
function LatexArray(T,texto,op,WorkPath)
  x=poly(0,'x');
  S=size(T) ;
  SS=size(S);
if SS(1)==1 & SS(2)==2 then
  fd_w = mopen(WorkPath + '\'+ texto + '.txt', 'wt');
  mfprintf(fd_w,'\\text{' + texto + ' } \\\\ \n');
  mfprintf(fd_w,'\\begin{array}{|');
  for i = 1 : S(2) mfprintf(fd_w,'c|'); end
  
  mfprintf(fd_w,'} \n');
    for i = 1 : S(1) 
         mfprintf(fd_w,'\\hline ');
        for j = 1 : S(2)
         if i == 1  & j ==1 then 
             mfprintf(fd_w,'%s\t', op );
         elseif i == 1  & j ==2 then // extend size of Zeros column (2))
             mfprintf(fd_w,'  %s \\hspace{5 mm}', string(T(i,j)) ); 
         else 
             mfprintf(fd_w,' %s\t', string(T(i,j)) ); 
         end
          if j<S(2) mfprintf(fd_w,'&' ); end
        end
        mfprintf(fd_w,'\\\\ \n');
    end
     mfprintf(fd_w,'\\hline \n');
    mfprintf(fd_w,'\\end{array}');
 mclose(fd_w);  
end
endfunction



function [AllPolyArray] =  PowParrangement(p,n,FieldElementPolyMatrix,WorkPath)
//this function get  all the FieldElementPolyMatrix combination 
// and return an array one dimmension of all the combination 
// of added poly elements, example for p=3 n=2 :
// with FieldElementPolyMatrix=
//   0    0  
//           
//   1    x  
//           
//   2    2x 
// 
// this function returns  0   1   2   x   1 +x   2 +x   2x   1 +2x   2 +2x
x=poly(0,'x');
irreduciblePolyR=(x^(n+1) - 1)/(x-1);
AllPolyArray=[] ;
SinglePoly=0 ;
PolyElementMatrix=[] ;
// reverse order of elements to order from small to high degree poly elements
FieldElementPolyMatrixf=flipdim(FieldElementPolyMatrix, 2);
bound=((p)^(n))-1 ; //size of FieldElementPolyMatrix (n-1) +1
indexM=[] ;
for i = 0:bound
 // conversion in base p of i from 0 to ((p)^(n))-1
 // the value of the digit gives the row index
 // and the position of the digit in base p gives the column index
 // example: for matrix p=3 n=2
//   0    0      
//             
//   1    x    
//            
//   2    2x   
//
// it will give 00 to 22 (0 to 8 but in base 3)
// 00 gives 0+0  
// 01 gives 0+x
// .....
// 22 gives 2 + 2x
 strIndexM = dec2base(i, p, n);
 strSplitIndexM=strsplit(strIndexM) ;
 IndexM=base2dec(strSplitIndexM,p)' ;
 SinglePoly=0 ;
 for colP=1:n
     rowP=IndexM(colP)+1 ;// 1 added to transpose 0:2 to 1:3 (case in example above)
    SinglePoly= SinglePoly + FieldElementPolyMatrixf(rowP,colP); // poly elements addition
 end
 AllPolyArray=[AllPolyArray  SinglePoly] ;
 //disp("one more poly element added !",pol2str(SinglePoly));
end 
 
disp("AllPolyArray Completed !",pol2str(AllPolyArray));
//fprintfMat(WorkPath +'\AllPolyArray ' +  string(p)+' Pow ' +  string(n)+".txt", AllPolyArray)  
//mclose(fd_w);
endfunction






//function  [FieldElements]=GetFieldElements(p,n,WorkPath,LetterOrPoly)
function  [AllFieldPolyArrayElements]=GetFieldElements(p,n,WorkPath)
x=poly(0,'x');
 //fd_w = mopen(WorkPath +'\debugEv.txt', 'at');
 N=p^n -p ;
//x=poly(0,'x');
// get numerical field elements
NaturalElements=[0:p-1 ]
// get polynomial field elements
mPoly = [];
//Create the poly array ,n=2 x,n=3 x x^2,n=4 x x^2 x^3
for i = 0:n-1
 mPoly=[mPoly x^i ] ;
end
//Create the  basic elements (a*x^i) poly matrix
// example p=3 (vertical size)n=3 (horizontal size)
//   0    0    0   
//              2 
//   1    x    x  
//               2
//   2    2x   2x 
// example p=3 (vertical size)n=5 (horizontal size)
//   0      0     0       0       0
//                
//   1      x     x^2     x^3     x^4
//               
//   2     2x    2x^2   2*x^3   2*x^4
FieldElementPolyMatrix = [];
for i = 0:p-1
 FieldElementPolyMatrix=[FieldElementPolyMatrix; (i)*mPoly ] ;
end
  
AllFieldPolyArrayElements=PowParrangement(p,n,FieldElementPolyMatrix,WorkPath);

//mfprintf(fd_w," n:%2d  p :%2d pStr:%s \n", n,p,pStr);
//mfprintf(fd_w," N:%2d  pStr1:%s  \n", N,pStr1);

//mclose(fd_w);
endfunction 

